'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

exports.default = createRouteDecorator;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _lodash = require('lodash.size');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.mapvalues');

var _lodash4 = _interopRequireDefault(_lodash3);

var _reduxPluginsImmutableReact = require('redux-plugins-immutable-react');

var _selectPluginRoutes = require('./selectPluginRoutes');

var _selectPluginRoutes2 = _interopRequireDefault(_selectPluginRoutes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function createRouteDecorator(store) {
  function wrapGetChildRoutes(func) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return function (location, cb) {
      var result = func.apply(undefined, [location].concat(_toConsumableArray(args), [function (err, routes) {
        if (err) return cb(err);
        return cb(null, decorateRoutes(routes));
      }]));
      if (result) cb(null, decorateRoutes(result));
    };
  }

  function decorateIndexRoute(route) {
    if (Array.isArray(route)) {
      if (route.length > 1) throw new Error("got more than one route for an index route: " + route);
      route = route[0];
    }
    if (_react2.default.isValidElement(route)) {
      route = (0, _reactRouter.createRoutes)(_jsx(_reactRouter.Route, {}, void 0, route))[0].indexRoute;
    }
    return decorateRoute(route);
  }

  function wrapGetIndexRoute(func) {
    for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    return function (location, cb) {
      var result = func.apply(undefined, [location].concat(_toConsumableArray(args), [function (err, route) {
        if (err) return cb(err);
        return cb(null, decorateIndexRoute(route));
      }]));
      if (result) cb(null, decorateIndexRoute(result));
    };
  }

  function decorateRoute(route) {
    if (!route) return route;

    var newProps = {};

    ////////////////////////////////////////////////////////////////////////////////
    // CHILD ROUTES
    ////////////////////////////////////////////////////////////////////////////////

    var getChildRoutes = route.getChildRoutes;
    var getChildRoutesFromStore = route.getChildRoutesFromStore;
    var getChildRoutesFromPlugin = route.getChildRoutesFromPlugin;
    var childRoutesKey = route.childRoutesKey;
    var childRoutes = route.childRoutes;


    if (getChildRoutes) {
      newProps.getChildRoutes = wrapGetChildRoutes(getChildRoutes);
    } else if (getChildRoutesFromStore) {
      newProps.getChildRoutes = wrapGetChildRoutes(getChildRoutesFromStore, store);
    } else if (getChildRoutesFromPlugin) {
      newProps.getChildRoutes = function (location, cb) {
        return cb(null, decorateRoutes((0, _selectPluginRoutes2.default)(function (plugin) {
          return getChildRoutesFromPlugin(location, plugin);
        })(store.getState())));
      };
    } else if (childRoutesKey) {
      newProps.getChildRoutes = function (location, cb) {
        return cb(null, decorateRoutes((0, _selectPluginRoutes2.default)(childRoutesKey)(store.getState())));
      };
    }
    if (childRoutes) newProps.childRoutes = decorateRoutes(childRoutes);

    ////////////////////////////////////////////////////////////////////////////////
    // INDEX ROUTE
    ////////////////////////////////////////////////////////////////////////////////

    var getIndexRoute = route.getIndexRoute;
    var getIndexRouteFromStore = route.getIndexRouteFromStore;
    var getIndexRouteFromPlugin = route.getIndexRouteFromPlugin;
    var indexRouteKey = route.indexRouteKey;
    var indexRoute = route.indexRoute;


    if (getIndexRoute) {
      newProps.getIndexRoute = wrapGetIndexRoute(getIndexRoute);
    }
    if (getIndexRouteFromStore) {
      newProps.getIndexRoute = wrapGetIndexRoute(getIndexRouteFromStore, store);
    }
    if (getIndexRouteFromPlugin) {
      newProps.getIndexRoute = function (location, cb) {
        return cb(null, decorateIndexRoute((0, _selectPluginRoutes2.default)(function (plugin) {
          return getIndexRouteFromPlugin(location, plugin);
        })(store.getState())));
      };
    }
    if (indexRouteKey) {
      newProps.getIndexRoute = function (location, cb) {
        return cb(null, decorateIndexRoute((0, _selectPluginRoutes2.default)(indexRouteKey)(store.getState())));
      };
    }
    if (indexRoute) newProps.indexRoute = decorateIndexRoute(indexRoute);

    ////////////////////////////////////////////////////////////////////////////////
    // COMPONENT
    ////////////////////////////////////////////////////////////////////////////////

    var getComponent = route.getComponent;
    var getComponentFromStore = route.getComponentFromStore;
    var getComponentFromPlugin = route.getComponentFromPlugin;
    var componentKey = route.componentKey;
    var pluginKey = route.pluginKey;
    var componentProps = route.componentProps;


    if (!getComponent && (getComponentFromStore || getComponentFromPlugin || componentKey)) {
      if (getComponentFromStore) {
        newProps.getComponent = function (nextState, cb) {
          return getComponentFromStore(nextState, store, cb);
        };
      } else if (getComponentFromPlugin) {
        if (pluginKey) {
          newProps.component = function (props) {
            return _jsx(_reduxPluginsImmutableReact.LoadPluginComponent, {
              getComponent: getComponentFromPlugin,
              pluginKey: pluginKey,
              componentProps: componentProps ? _extends({}, componentProps, props) : props
            });
          };
        } else {
          newProps.component = function (props) {
            return _jsx(_reduxPluginsImmutableReact.PluginComponents, {
              getComponent: getComponentFromPlugin,
              componentProps: componentProps ? _extends({}, componentProps, props) : props
            });
          };
        }
      } else if (componentKey) {
        if (pluginKey) {
          newProps.component = function (props) {
            return _jsx(_reduxPluginsImmutableReact.LoadPluginComponent, {
              componentKey: componentKey,
              pluginKey: pluginKey,
              componentProps: componentProps ? _extends({}, componentProps, props) : props
            });
          };
        } else {
          newProps.component = function (props) {
            return _jsx(_reduxPluginsImmutableReact.PluginComponents, {
              componentKey: componentKey,
              componentProps: componentProps ? _extends({}, componentProps, props) : props
            });
          };
        }
      }
    }

    ////////////////////////////////////////////////////////////////////////////////
    // COMPONENTS
    ////////////////////////////////////////////////////////////////////////////////

    var getComponents = route.getComponents;
    var getComponentsFromStore = route.getComponentsFromStore;
    var getComponentsFromPlugin = route.getComponentsFromPlugin;
    var componentKeys = route.componentKeys;


    if (!getComponents && (getComponentsFromStore || getComponentsFromPlugin || componentKeys)) {
      if (getComponentsFromStore) {
        newProps.getComponents = function (nextState, cb) {
          return getComponentsFromStore(nextState, store, cb);
        };
      } else if (componentKeys) {
        if (pluginKey) {
          newProps.components = (0, _lodash4.default)(componentKeys, function (componentKey) {
            return function (props) {
              return _jsx(_reduxPluginsImmutableReact.LoadPluginComponent, {
                componentKey: componentKey,
                pluginKey: pluginKey,
                componentProps: componentProps ? _extends({}, componentProps, props) : props
              });
            };
          });
        } else {
          newProps.components = (0, _lodash4.default)(componentKeys, function (componentKey) {
            return function (props) {
              return _jsx(_reduxPluginsImmutableReact.PluginComponents, {
                componentKey: componentKey,
                componentProps: componentProps ? _extends({}, componentProps, props) : props
              });
            };
          });
        }
      }
    }

    return (0, _lodash2.default)(newProps) ? _extends({}, route, newProps) : route;
  }

  function decorateRoutes(routes) {
    if (!routes) return routes;
    return (0, _reactRouter.createRoutes)(routes).map(decorateRoute);
  }

  return decorateRoutes;
}